=== debian/changelog ===
gvmd (9.0.1-3ubuntu1) groovy; urgency=medium

  * Fix FTBFS and autopkgtest with glibc 2.32

 -- Balint Reczey <rbalint@ubuntu.com>  Wed, 16 Sep 2020 14:10:08 +0200

gvmd (9.0.1-3) unstable; urgency=medium

  * Team upload.

  [ Sophie Brun ]
  * store the postgresql version for check in gvm package

 -- Raphaël Hertzog <hertzog@debian.org>  Fri, 07 Aug 2020 21:22:43 +0200

gvmd (9.0.1-2) unstable; urgency=medium

  * Team upload.

  [ Sophie Brun ]
  * Fix SQL query in Fix-gvm-migrate-to-postgres.patch (Closes: #966632)
  * Update gvmd.service to start after ospd-openvas

 -- Raphaël Hertzog <raphael@offensive-security.com>  Thu, 06 Aug 2020 14:54:15 +0200

gvmd (9.0.1-1) unstable; urgency=medium

  * Team upload

  [ Sophie Brun ]
  * Import upstream patch to fix db migration
  * Update debian/README.Debian

  [ Raphaël Hertzog ]
  * Remove obsolete field Name from debian/upstream/metadata (already present
    in machine-readable debian/copyright).
  * Get rid of /var/lib/gvm/{private,}/CA during purge (Closes: #905518)
  * Extend descriptions of patches

 -- Raphaël Hertzog <raphael@offensive-security.com>  Fri, 31 Jul 2020 17:04:50 +0200

gvmd (9.0.1-1~exp1) experimental; urgency=medium

  [ Sophie Brun ]
  * Switch to gvmd
  * New upstream version 9.0.0
  * Switch all debian/* to gvmd
  * Update docs installation
  * Add missing DPostgreSQL_TYPE_INCLUDE_DIR in debian/rules
  * Add a patch to fix small spelling error
  * Update debian/gvmd.service
  * Update debian/copyright
  * Update Vcs-* fields for gvmd
  * Import upstream patch to fix gvm-portnames-update
  * Use postgres in gvm-portnames-update
  * Bump Standards-Version to 4.5.0
  * Use debhelper-compat 12
  * Use a special user _gvm and change GVM_RUN_DIR
  * Don't start service after installation
  * Add /var/lib/gvm/private directory
  * Update gvmd.service to use ospd
  * New upstream version 9.0.1
  * Update minimal required version of libgvm11
  * Improve gvmd.service
  * Add permissions to /var/log/gvm and /var/lib/gvm
  * Remove change-GVM_RUN_DIR.patch, use parameter to change GVM_RUN_DIR
  * Fix debian/gvmd.logrotate with user _gvm and pid location
  * Add missing dependency: postgresql
  * Add a patch to change lockfile location

  [ Samuel Henrique ]
  * Configure git-buildpackage for Debian

  [ SZ Lin (林上智) ]
  * Add autopkgtest test case
  * Add patch for removing tests of removed functions
  * Move adduser package from B-D to D for postinst usage
  * Update copyright information
  * Update uploaders information
  * Set Rules-Requires-Root: no
  * Bump debhelper-compat to 13
  * Add upstream metadata

 -- SZ Lin (林上智) <szlin@debian.org>  Fri, 03 Jul 2020 10:43:27 +0800

openvas-manager (7.0.3-1) unstable; urgency=medium

  [ Sophie Brun ]
  * Team upload.
  * Update debian/watch and debian/control with new upstream github repository
  * Import new usptream release
  * Update date in debian/copyright
  * Update minimal required version of libopenvas-dev
  * Add texlive-latex-extra in Recommends (see
    https://bugs.kali.org/view.php?id=4839)

  [ Raphaël Hertzog ]
  * Drop the patch, it has been merged upstream.
  * Bump Standards-Version to 4.1.5.

 -- Sophie Brun <sophie@freexian.com>  Fri, 06 Jul 2018 14:57:27 +0200

openvas-manager (7.0.2-4) unstable; urgency=medium

  * Team upload.
  * Revert "Replace insecure URI to secure URI in d/watch"
  * Clean up rules file
    - use dh_missing --fail-missing instead of dh_install's option
    - move some commands to their logical place (fix permissions in
      override_dh_fixperms, dropping installed files right after their
      installation)
  * Add usual values to openvas-manager.init's Default-Start field
  * Drop debian/.git-dpm, we don't use that tool
  * Install upstream's README properly
  * Drop debian/openvas-manager.manpages since manual pages are installed by
    cmake
  * Install files from /usr/share/man/man1/ in openvas-manager-common too
  * Automatically setup the required certificate files in the postinst

 -- Raphaël Hertzog <hertzog@debian.org>  Fri, 06 Apr 2018 00:04:52 +0200

openvas-manager (7.0.2-3) unstable; urgency=medium

  [ Raphaël Hertzog ]
  * Update Vcs-Git and Vcs-Browser for the move to salsa.debian.org
  * Update team maintainer address to Debian Security Tools

  [ Helmut Grohne ]
  * Drop unused Build-Depends: flawfinder. (Closes: #893918)

  [ SZ Lin (林上智) ]
  * d/control: Bump standards version to 4.1.3
  * d/control: Bump version of "debhelper" to 11
  * d/compat: Bump compat version to 11
  * d/watch: Replace insecure URI to secure URI
  * d/copyright: Replace insecure URI to secure URI

 -- SZ Lin (林上智) <szlin@debian.org>  Wed, 04 Apr 2018 21:51:26 +0800

openvas-manager (7.0.2-2) unstable; urgency=medium

  [ Javier Fernández-Sanguino Peña ]
  * Merge previous changelog entries from the package that were in
    experimental some years ago (Closes: #873967)

  [ SZ Lin (林上智) ]
  * d/control: Bump standards version to 4.1.2
  * d/control: Bump version of "debhelper" to 10
  * d/compat: Bump compat version to 10
  * d/rules: Remove unnecessary parameter in dh
  * Import patch from upstream to fix scheduled task failing issue
    (Closes: #868123)

 -- SZ Lin (林上智) <szlin@debian.org>  Fri, 01 Dec 2017 14:30:20 +0800

openvas-manager (7.0.2-1) unstable; urgency=medium

  * Import new upstream release

 -- SZ Lin (林上智) <szlin@debian.org>  Thu, 29 Jun 2017 17:10:43 +0800

openvas-manager (7.0.1-3) unstable; urgency=medium

  * Fix FTBFS issue (Closes: #865291)

 -- SZ Lin (林上智) <szlin@debian.org>  Tue, 20 Jun 2017 23:35:04 +0800

openvas-manager (7.0.1-2) unstable; urgency=medium

  * Move package from experimental to sid archive
  * Bump standards version to 4.0.0

 -- SZ Lin (林上智) <szlin@debian.org>  Tue, 20 Jun 2017 11:28:21 +0800

openvas-manager (7.0.1-1~exp1) experimental; urgency=medium

  * Import new upstream release

 -- SZ Lin (林上智) <szlin@debian.org>  Wed, 22 Mar 2017 20:17:38 +0800


