=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr -DSYSCONFDIR=/etc -DLOCALSTATEDIR=/var -DCMAKE_BUILD_TYPE=release -DPostgreSQL_TYPE_INCLUDE_DIR=/usr/include/postgresql -DBACKEND=POSTGRESQL -DGVM_RUN_DIR=/var/run/gvm

override_dh_auto_install:
	dh_auto_install
	rm -f debian/tmp/usr/share/gvm/gvm-lsc-rpm-creator.sh
# store the postgresql version used for compilation so that we can check
# that we have the same version in gvm-setup / gvm-check-setup during runtime
	mkdir -p debian/tmp/usr/share/gvmd
	pkg-config --modversion libpq > debian/tmp/usr/share/gvmd/postgresql-version

override_dh_auto_test:
	# disabled because make check fails

override_dh_missing:
	dh_missing --fail-missing

override_dh_fixperms-indep:
	find debian/gvmd-common/usr/share/gvm/gvmd -name alert -o -name generate | \
		xargs --no-run-if-empty chmod 755
	dh_fixperms

override_dh_installsystemd:
	dh_installsystemd --no-start

override_dh_installinit:
	dh_installinit --no-start
